commit a620451032abb28343c31438a4e779ea5d2e1bbf
Author: Kyrylo Tkachov <kyrylo.tkachov@arm.com>
Date:   Wed May 24 10:33:04 2023

    arm: PR target/109939 Correct signedness of return type of __ssat intrinsics
    
    As the PR says we shouldn't be using qualifier_unsigned for the return type of the __ssat intrinsics.
    UNSIGNED_SAT_BINOP_UNSIGNED_IMM_QUALIFIERS already exists for that.
    This was just a thinko.
    This patch fixes this and the warning with -Wconversion goes away.
    
    Bootstrapped and tested on arm-none-linux-gnueabihf.
    
    gcc/ChangeLog:
    
            PR target/109939
            * config/arm/arm-builtins.cc (SAT_BINOP_UNSIGNED_IMM_QUALIFIERS): Use
            qualifier_none for the return operand.
    
    gcc/testsuite/ChangeLog:
    
            PR target/109939
            * gcc.target/arm/pr109939.c: New test.
    
    (cherry picked from commit 95542a6ec4b350c653b793b7c36a8210b0e9a89d)

diff --git a/gcc/config/arm/arm-builtins.cc b/gcc/config/arm/arm-builtins.cc
index 36a40a1dc80..557d6f68fd1 100644
--- a/gcc/config/arm/arm-builtins.cc
+++ b/gcc/config/arm/arm-builtins.cc
@@ -97,7 +97,7 @@ arm_binop_imm_qualifiers[SIMD_MAX_BUILTIN_ARGS]
 /* T (T, unsigned immediate).  */
 static enum arm_type_qualifiers
 arm_sat_binop_imm_qualifiers[SIMD_MAX_BUILTIN_ARGS]
-  = { qualifier_unsigned, qualifier_none, qualifier_unsigned_immediate };
+  = { qualifier_none, qualifier_none, qualifier_unsigned_immediate };
 #define SAT_BINOP_UNSIGNED_IMM_QUALIFIERS \
   (arm_sat_binop_imm_qualifiers)
 
diff --git a/gcc/testsuite/gcc.target/arm/pr109939.c b/gcc/testsuite/gcc.target/arm/pr109939.c
new file mode 100644
index 00000000000..aafda7cd3cd
--- /dev/null
+++ b/gcc/testsuite/gcc.target/arm/pr109939.c
@@ -0,0 +1,14 @@
+/* { dg-do compile } */
+/* { dg-require-effective-target arm_sat_ok } */
+/* { dg-add-options arm_sat } */
+/* { dg-additional-options "-O -Wall -Wconversion" } */
+
+#include <arm_acle.h>
+
+int dbg_ssat_out;
+int dbg_ssat_in;
+
+void test_arm_ssat(void)
+{
+    dbg_ssat_out = __ssat(dbg_ssat_in, 16);
+}

